# Copyright (C) 2000-2003 Aver Development Corporation / Purple Magma Corporation. All Rights Reserved.

from __future__ import division

import sets


# There is a recurring desire to use weakrefs for listeners. This does not
# work because often the only references to the providers are within the
# broadcaster and hence would be garbage collected immediately.

class Broadcaster(object):
	__slots__ = ()

	debug = False
	listeners = {}
	currentTitles = []
	currentData = []

	def EnableDebugging(self, enable=True):
		Broadcaster.debug = enable


	def Register(self, title, listener):
		if Broadcaster.debug:
			print r'Registering listener for "%s"' % title
		Broadcaster.listeners.setdefault(title, sets.Set()).add(listener)


	def Broadcast(self, title, **data):
		Broadcaster.currentTitles.append(title)
		Broadcaster.currentData.append(data)

		listenerSet = Broadcaster.listeners.get(title, sets.Set())

		if Broadcaster.debug:
			print r'Broadcasting "%s" to %d listeners' % (title, len(listenerSet))

		for listener in listenerSet:
			listener()

		Broadcaster.currentTitles.pop()
		Broadcaster.currentData.pop()


	def CurrentTitle(self):
		if Broadcaster.currentTitles:
			return Broadcaster.currentTitles[-1]
		else:
			return None


	def CurrentData(self):
		if Broadcaster.currentData:
			return Broadcaster.currentData[-1]
		else:
			return None
